<img src="docs/illustrations/vipslogo_512.png" alt="VIPS Logo" height="250"/>

# ReferenceModel
This VIPS model is **an example only, without any actual agronomic value**. It provides examples of how you
create your own pest prediction model that can be deployed to a [VIPSCore-Python server](https://gitlab.nibio.no/VIPS/VIPSCore-Python) deployment.

## How to deploy this model
See the [VIPSCore-Python README](https://gitlab.nibio.no/VIPS/VIPSCore-Python#install-vips-models) for how to make it available on that server. 

## Testing
The tests are located in the `tests` folder, and we're using [Pytest](https://docs.pytest.org/)

To run the unit tests, move to the root folder of the project, and execute:

``` bash
pytest -v
```

### Using bumpver
For developers: When you want to publish a new version, use
``` bash
# Increment the PATCH version when you make backwards compatible bug fixes.
bumpver update --patch
# Increment the MINOR version when you add functionality in a backwards compatible manner.
bumpver update --minor
# Increment the MAJOR version when you make incompatible API changes.
bumpver update --major
```
[(Source)](https://semver.org/#summary)

## References
We used this excellent guide for packaging: https://realpython.com/pypi-publish-python-package/ 

## Translations
We're using a simple dictionary translation system, with a module translations.py, where we
simply define some dictionaries with language codes as property, looking like this:

```python
name = {
    "en":   "Reference Model",
    "nb":   "Referansemodell",
}
```

This is used in the main module like this:

```python
[...]
from . import translations
[...]
def get_model_name(self, language = VIPSModel.default_language) -> str:
        """Returns the model name in the specified language (<a href="http://www.loc.gov/standards/iso639-2/php/English_list.php">ISO-639-2</a>)"""
        return translations.name.get(language, translations.name.get(VIPSModel.default_language, "NOT FOUND"))  
[...]
```